library isyumi;

import "httpserver.dart";

typedef void OnConnection(Cookies cookies,URL url,Document document);



void onConnection(OnConnection f){
  start_server().listen((connection) => new Client(f,connection));
}

class Client{
  
  OnConnection _onConnection;
  Connection _connection;
  
  States states;
  
  URL url;
  Cookies cookies;
  Document document;
  
  Client(this._onConnection,this._connection){
    cookies = new Cookies(_connection);
    _connection.ip.url.onData.listen(onUrlChange);
  }
  
  
  void onUrlChange(Null n){
    
    if(url == null){
      url = new URL(_connection.ip.url.url.value);
      states = new States(cookies,url);
      
      _onConnection(cookies,url,document);
      
      states.start();
      
      return;
    }
    
    url.change((str) => _connection.ip.url.url.value);
  }
  
}

class States{
  List<State> states;
  
  List<Where> _wheres;
  
  States(Cookies cookes,URL url);
  
  void start(){
    for(Where where in _wheres){
      where._check();
    }
  }
  
}



class State<T>{
  
  Where where(bool f(T t)) => new Where._(this,f);
  
  void change(void f(T t)){
    
  }
  
}

class URL extends State<String>{
  
  URL(String initial_url);
  
}

class Cookies extends State<List<Cookie>>{
  
  List<Cookie> _cookies = []; 
  
  Cookies(Connection connection){
    connection.cookies((name,value)=> new Cookie(name,value));
  }
}

class Cookie{
  
  final String name,value;
  
  Cookie(this.name,this.value);
  
}

class Where{
  
  List<Then>_thens;
  
  Where._(State state,bool f(t)){
    
  }
  
  void then(void f()){
    
  }
  
  Where operator & (Where where){
    
  }
  
  Where operator | (Where where){
    
  }
  
  void _check(){
    _thens.forEach((then) =>then._do());
  }
  
}

class Then{
  
  void _do(){
    
    
    
  }
  
}

typedef void CtrlDef<T extends Controle>(T t);

class Document{
  
  List<Controle> _controles;
  
  void text(CtrlDef<Text> f){
    
  }
  
  void div(CtrlDef<Div> f){
    
  }
  
  void text_input(CtrlDef<TextInput> f){
    
  }
  
  void password_input(CtrlDef<PasswordInput> f){
    
  }
  
  void anchor(CtrlDef<Anchor> f){
    
  }
  
  void img(CtrlDef<Image> f){
    
  }
  
}

abstract class Controle{
   
  Where _where;
  
}

class Text extends Controle{
  set text (String str){
    
  }
}

class Div extends Controle{
  
}

class TextInput extends Controle{
  
}

class PasswordInput extends Controle{
  
}

class Anchor extends Controle{
  
}

class Image extends Controle{
  
}